diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-route-manager-impl.cc ns-3.47/src/internet/model/global-route-manager-impl.cc
--- ns-3.46/src/internet/model/global-route-manager-impl.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-route-manager-impl.cc	2026-02-16 16:08:49.611230000 -0800
@@ -1264,7 +1341,7 @@
     }
     if (transits == 1)
     {
-        if (transitLink->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork)
+        if (transitLink->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::TransitNetwork)
         {
             // Install default route to next hop router
             // What is the next hop?  We need to check all neighbors on the link.
@@ -1275,20 +1352,20 @@
             NS_LOG_LOGIC("TBD: Would have inserted default for transit");
             return false;
         }
-        else if (transitLink->GetLinkType() == GlobalRoutingLinkRecord::PointToPoint)
+        else if (transitLink->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::PointToPoint)
         {
             // Install default route to next hop
             // The link record LinkID is the router ID of the peer.
             // The Link Data is the local IP interface address
-            GlobalRoutingLSA* w_lsa = m_lsdb->GetLSA(transitLink->GetLinkId());
+            GlobalRoutingLSA<IpManager>* w_lsa = m_lsdb->GetLSA(transitLink->GetLinkId());
             uint32_t nLinkRecords = w_lsa->GetNLinkRecords();
             for (uint32_t j = 0; j < nLinkRecords; ++j)
             {
                 //
                 // We are only concerned about point-to-point links
                 //
-                GlobalRoutingLinkRecord* lr = w_lsa->GetLinkRecord(j);
-                if (lr->GetLinkType() != GlobalRoutingLinkRecord::PointToPoint)
+                GlobalRoutingLinkRecord<IpManager>* lr = w_lsa->GetLinkRecord(j);
+                if (lr->GetLinkType() != GlobalRoutingLinkRecord<IpManager>::PointToPoint)
                 {
                     continue;
                 }
@@ -1296,18 +1373,34 @@
                 if (lr->GetLinkId() == myRouterId)
                 {
                     // Next hop is stored in the LinkID field of lr
-                    Ptr<GlobalRouter> router = rlsa->GetNode()->GetObject<GlobalRouter>();
+                    Ptr<GlobalRouter<IpManager>> router =
+                        rlsa->GetNode()->template GetObject<GlobalRouter<IpManager>>();
                     NS_ASSERT(router);
-                    Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+                    Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
                     NS_ASSERT(gr);
-                    gr->AddNetworkRouteTo(Ipv4Address("0.0.0.0"),
-                                          Ipv4Mask("0.0.0.0"),
-                                          lr->GetLinkData(),
-                                          FindOutgoingInterfaceId(transitLink->GetLinkData()));
-                    NS_LOG_LOGIC("Inserting default route for node "
-                                 << myRouterId << " to next hop " << lr->GetLinkData()
-                                 << " via interface "
-                                 << FindOutgoingInterfaceId(transitLink->GetLinkData()));
+                    if constexpr (IsIpv4)
+                    {
+                        gr->AddNetworkRouteTo(IpAddress::GetZero(),
+                                              IpMaskOrPrefix::GetZero(),
+                                              lr->GetLinkData(),
+                                              FindOutgoingInterfaceId(transitLink->GetLinkData()));
+                        NS_LOG_LOGIC("Inserting default route for node "
+                                     << myRouterId << " to next hop " << lr->GetLinkData()
+                                     << " via interface "
+                                     << FindOutgoingInterfaceId(transitLink->GetLinkData()));
+                    }
+                    else
+                    {
+                        gr->AddNetworkRouteTo(
+                            IpAddress::GetZero(),
+                            IpMaskOrPrefix::GetZero(),
+                            lr->GetLinkLocData(),
+                            FindOutgoingInterfaceId(transitLink->GetLinkLocData()));
+                        NS_LOG_LOGIC("Inserting default route for node "
+                                     << myRouterId << " to next hop " << lr->GetLinkLocData()
+                                     << " via interface "
+                                     << FindOutgoingInterfaceId(transitLink->GetLinkLocData()));
+                    }
                     return true;
                 }
             }
@@ -1317,12 +1410,14 @@
 }
 
 // quagga ospf_spf_calculate
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFCalculate(Ipv4Address root)
+GlobalRouteManagerImpl<T>::SPFCalculate(IpAddress root)
 {
     NS_LOG_FUNCTION(this << root);
 
-    SPFVertex* v;
+    SPFVertex<T>* v;
     //
     // Initialize the Link State Database.
     //
@@ -1332,21 +1427,21 @@
     // of the queue being the closest vertex in terms of distance from the root
     // of the tree.  Initially, this queue is empty.
     //
-    CandidateQueue candidate;
+    CandidateQueue<T> candidate;
     NS_ASSERT(candidate.Size() == 0);
     //
     // Initialize the shortest-path tree to only contain the router doing the
     // calculation.  Each router (and corresponding network) is a vertex in the
     // shortest path first (SPF) tree.
     //
-    v = new SPFVertex(m_lsdb->GetLSA(root));
+    v = new SPFVertex<T>(m_lsdb->GetLSA(root));
     //
     // This vertex is the root of the SPF tree and it is distance 0 from the root.
     // We also mark this vertex as being in the SPF tree.
     //
     m_spfroot = v;
     v->SetDistanceFromRoot(0);
-    v->GetLSA()->SetStatus(GlobalRoutingLSA::LSA_SPF_IN_SPFTREE);
+    v->GetLSA()->SetStatus(GlobalRoutingLSA<IpManager>::LSA_SPF_IN_SPFTREE);
     NS_LOG_LOGIC("Starting SPFCalculate for node " << root);
 
     //
@@ -1407,7 +1502,7 @@
         // Update the status field of the vertex to indicate that it is in the SPF
         // tree.
         //
-        v->GetLSA()->SetStatus(GlobalRoutingLSA::LSA_SPF_IN_SPFTREE);
+        v->GetLSA()->SetStatus(GlobalRoutingLSA<IpManager>::LSA_SPF_IN_SPFTREE);
         //
         // The current vertex has a parent pointer.  By calling this rather oddly
         // named method (blame quagga) we add the current vertex to the list of
@@ -1444,11 +1539,11 @@
         // through its point-to-point links, adding a *host* route to the local IP
         // address (at the <v> side) for each of those links.
         //
-        if (v->GetVertexType() == SPFVertex::VertexRouter)
+        if (v->GetVertexType() == SPFVertex<T>::VertexRouter)
         {
             SPFIntraAddRouter(v);
         }
-        else if (v->GetVertexType() == SPFVertex::VertexNetwork)
+        else if (v->GetVertexType() == SPFVertex<T>::VertexNetwork)
         {
             SPFIntraAddTransit(v);
         }
@@ -1468,7 +1563,7 @@
     for (uint32_t i = 0; i < m_lsdb->GetNumExtLSAs(); i++)
     {
         m_spfroot->ClearVertexProcessed();
-        GlobalRoutingLSA* extlsa = m_lsdb->GetExtLSA(i);
+        GlobalRoutingLSA<IpManager>* extlsa = m_lsdb->GetExtLSA(i);
         NS_LOG_LOGIC("Processing External LSA with id " << extlsa->GetLinkStateId());
         ProcessASExternals(m_spfroot, extlsa);
     }
@@ -1482,16 +1577,17 @@
     m_spfroot = nullptr;
 }
 
+template <typename T>
 void
-GlobalRouteManagerImpl::ProcessASExternals(SPFVertex* v, GlobalRoutingLSA* extlsa)
+GlobalRouteManagerImpl<T>::ProcessASExternals(SPFVertex<T>* v, GlobalRoutingLSA<IpManager>* extlsa)
 {
     NS_LOG_FUNCTION(this << v << extlsa);
     NS_LOG_LOGIC("Processing external for destination "
                  << extlsa->GetLinkStateId() << ", for router " << v->GetVertexId()
                  << ", advertised by " << extlsa->GetAdvertisingRouter());
-    if (v->GetVertexType() == SPFVertex::VertexRouter)
+    if (v->GetVertexType() == SPFVertex<T>::VertexRouter)
     {
-        GlobalRoutingLSA* rlsa = v->GetLSA();
+        GlobalRoutingLSA<IpManager>* rlsa = v->GetLSA();
         NS_LOG_LOGIC("Processing router LSA with id " << rlsa->GetLinkStateId());
         if ((rlsa->GetLinkStateId()) == (extlsa->GetAdvertisingRouter()))
         {
@@ -1515,8 +1611,9 @@
 // SPFAddIntraAddStub()
 //
 
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFAddASExternal(GlobalRoutingLSA* extlsa, SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFAddASExternal(GlobalRoutingLSA<IpManager>* extlsa, SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << extlsa << v);
 
@@ -1532,7 +1629,7 @@
     NS_LOG_LOGIC("External is on remote host: " << extlsa->GetAdvertisingRouter()
                                                 << "; installing");
 
-    Ipv4Address routerId = m_spfroot->GetVertexId();
+    IpAddress routerId = m_spfroot->GetVertexId();
 
     NS_LOG_LOGIC("Vertex ID = " << routerId);
     //
@@ -1551,7 +1648,7 @@
     // to QI for that interface.  If there's no GlobalRouter interface, the node
     // in question cannot be the router we want, so we continue.
     //
-    Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+    Ptr<GlobalRouter<T>> router = node->GetObject<GlobalRouter<T>>();
     NS_ASSERT_MSG(router, "No GlobalRouter interface on SPF root node " << node->GetId());
     //
     // If the router ID of the current node is equal to the router ID of the
@@ -1566,7 +1663,7 @@
         // for that interface.  If the node is acting as an IP version 4 router, it
         // should absolutely have an Ipv4 interface.
         //
-        Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
+        Ptr<Ip> ipv4 = node->GetObject<Ip>();
         NS_ASSERT_MSG(ipv4,
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "QI for <Ipv4> interface failed");
@@ -1579,9 +1676,17 @@
         NS_ASSERT_MSG(v->GetLSA(),
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "Expected valid LSA in SPFVertex* v");
-        Ipv4Mask tempmask = extlsa->GetNetworkLSANetworkMask();
-        Ipv4Address tempip = extlsa->GetLinkStateId();
-        tempip = tempip.CombineMask(tempmask);
+        IpMaskOrPrefix tempmask = extlsa->GetNetworkLSANetworkMask();
+        IpAddress tempip = extlsa->GetLinkStateId();
+
+        if constexpr (IsIpv4)
+        {
+            tempip = tempip.CombineMask(tempmask);
+        }
+        else
+        {
+            tempip = tempip.CombinePrefix(tempmask);
+        }
 
         //
         // Here's why we did all of that work.  We're going to add a host route to the
@@ -1596,18 +1701,18 @@
         // Similarly, the vertex <v> has an m_rootOif (outbound interface index) to
         // which the packets should be send for forwarding.
         //
-        Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+        Ptr<GlobalRouter<IpManager>> router = node->GetObject<GlobalRouter<IpManager>>();
 
         NS_ASSERT_MSG(router, "No GlobalRouter interface on node " << node->GetId());
 
-        Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+        Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
         NS_ASSERT(gr);
         // walk through all next-hop-IPs and out-going-interfaces for reaching
         // the stub network gateway 'v' from the root node
         for (uint32_t i = 0; i < v->GetNRootExitDirections(); i++)
         {
-            SPFVertex::NodeExit_t exit = v->GetRootExitDirection(i);
-            Ipv4Address nextHop = exit.first;
+            typename SPFVertex<T>::NodeExit_t exit = v->GetRootExitDirection(i);
+            IpAddress nextHop = exit.first;
             int32_t outIf = exit.second;
             if (outIf >= 0)
             {
@@ -1634,21 +1739,23 @@
 // Processing logic from RFC 2328, page 166 and quagga ospf_spf_process_stubs ()
 // stub link records will exist for point-to-point interfaces and for
 // broadcast interfaces for which no neighboring router can be found
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFProcessStubs(SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFProcessStubs(SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << v);
     NS_LOG_LOGIC("Processing stubs for " << v->GetVertexId());
-    if (v->GetVertexType() == SPFVertex::VertexRouter)
+    if (v->GetVertexType() == SPFVertex<T>::VertexRouter)
     {
-        GlobalRoutingLSA* rlsa = v->GetLSA();
+        GlobalRoutingLSA<IpManager>* rlsa = v->GetLSA();
         NS_LOG_LOGIC("Processing router LSA with id " << rlsa->GetLinkStateId());
         for (uint32_t i = 0; i < rlsa->GetNLinkRecords(); i++)
         {
             NS_LOG_LOGIC("Examining link " << i << " of " << v->GetVertexId() << "'s "
                                            << v->GetLSA()->GetNLinkRecords() << " link records");
-            GlobalRoutingLinkRecord* l = v->GetLSA()->GetLinkRecord(i);
-            if (l->GetLinkType() == GlobalRoutingLinkRecord::StubNetwork)
+            GlobalRoutingLinkRecord<IpManager>* l = v->GetLSA()->GetLinkRecord(i);
+            if (l->GetLinkType() == GlobalRoutingLinkRecord<IpManager>::StubNetwork)
             {
                 NS_LOG_LOGIC("Found a Stub record to " << l->GetLinkId());
                 SPFIntraAddStub(l, v);
@@ -1667,8 +1774,10 @@
 }
 
 // RFC2328 16.1. second stage.
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFIntraAddStub(GlobalRoutingLinkRecord* l, SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFIntraAddStub(GlobalRoutingLinkRecord<IpManager>* l, SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << l << v);
 
@@ -1692,7 +1801,7 @@
     // going to use this ID to discover which node it is that we're actually going
     // to update.
     //
-    Ipv4Address routerId = m_spfroot->GetVertexId();
+    IpAddress routerId = m_spfroot->GetVertexId();
 
     NS_LOG_LOGIC("Vertex ID = " << routerId);
     //
@@ -1710,7 +1819,7 @@
     // to QI for that interface.  If there's no GlobalRouter interface, the node
     // in question cannot be the router we want, so we continue.
     //
-    Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+    Ptr<GlobalRouter<T>> router = node->GetObject<GlobalRouter<T>>();
     NS_ASSERT_MSG(router, "No GlobalRouter interface on node " << node->GetId());
     //
     // If the router ID of the current node is equal to the router ID of the
@@ -1725,8 +1834,8 @@
         // for that interface.  If the node is acting as an IP version 4 router, it
         // should absolutely have an Ipv4 interface.
         //
-        Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
-        NS_ASSERT_MSG(ipv4,
+        Ptr<Ip> ip = node->GetObject<Ip>();
+        NS_ASSERT_MSG(ip,
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "QI for <Ipv4> interface failed");
         //
@@ -1738,9 +1847,28 @@
         NS_ASSERT_MSG(v->GetLSA(),
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "Expected valid LSA in SPFVertex* v");
-        Ipv4Mask tempmask(l->GetLinkData().Get());
-        Ipv4Address tempip = l->GetLinkId();
-        tempip = tempip.CombineMask(tempmask);
+        IpMaskOrPrefix tempmask;
+        if constexpr (IsIpv4)
+        {
+            tempmask = Ipv4Mask(l->GetLinkData().Get());
+        }
+        else
+        {
+            // to get the Prefix from the Ipv6Address
+            uint8_t buf[16];
+            l->GetLinkData().GetBytes(buf);
+            tempmask = Ipv6Prefix(buf);
+        }
+
+        IpAddress tempip = l->GetLinkId();
+        if constexpr (IsIpv4)
+        {
+            tempip = tempip.CombineMask(tempmask);
+        }
+        else
+        {
+            tempip = tempip.CombinePrefix(tempmask);
+        }
         //
         // Here's why we did all of that work.  We're going to add a host route to the
         // host address found in the m_linkData field of the point-to-point link
@@ -1755,16 +1883,16 @@
         // which the packets should be send for forwarding.
         //
 
-        Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+        Ptr<GlobalRouter<T>> router = node->GetObject<GlobalRouter<T>>();
 
-        Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+        Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
         NS_ASSERT(gr);
         // walk through all next-hop-IPs and out-going-interfaces for reaching
         // the stub network gateway 'v' from the root node
         for (uint32_t i = 0; i < v->GetNRootExitDirections(); i++)
         {
-            SPFVertex::NodeExit_t exit = v->GetRootExitDirection(i);
-            Ipv4Address nextHop = exit.first;
+            typename SPFVertex<T>::NodeExit_t exit = v->GetRootExitDirection(i);
+            IpAddress nextHop = exit.first;
             int32_t outIf = exit.second;
             if (outIf >= 0)
             {
@@ -1794,8 +1922,10 @@
 // If no such interface is found, return -1 (note:  unit test framework
 // for routing assumes -1 to be a legal return value)
 //
+
+template <typename T>
 int32_t
-GlobalRouteManagerImpl::FindOutgoingInterfaceId(Ipv4Address a, Ipv4Mask amask)
+GlobalRouteManagerImpl<T>::FindOutgoingInterfaceId(IpAddress a, IpMaskOrPrefix amask)
 {
     NS_LOG_FUNCTION(this << a << amask);
     //
@@ -1806,7 +1936,7 @@
     // node in order to iterate the interfaces and find the one corresponding to
     // the address in question.
     //
-    Ipv4Address routerId = m_spfroot->GetVertexId();
+    IpAddress routerId = m_spfroot->GetVertexId();
     //
     // The node we need to add routes to is the node corresponding to the root vertex.
     // This is the node for which we are building the routing table.
@@ -1821,7 +1951,7 @@
         return -1;
     }
 
-    Ptr<GlobalRouter> rtr = node->GetObject<GlobalRouter>();
+    Ptr<GlobalRouter<IpManager>> rtr = node->GetObject<GlobalRouter<IpManager>>();
     NS_ASSERT_MSG(rtr, "No GlobalRouter interface on node " << node->GetId());
     //
     // If the node doesn't have a GlobalRouter interface it can't be the one
@@ -1836,8 +1966,8 @@
         // is participating in routing IP version 4 packets, it certainly must have
         // an Ipv4 interface.
         //
-        Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
-        NS_ASSERT_MSG(ipv4,
+        Ptr<Ip> ip = node->GetObject<Ip>();
+        NS_ASSERT_MSG(ip,
                       "GlobalRouteManagerImpl::FindOutgoingInterfaceId (): "
                       "GetObject for <Ipv4> interface failed");
         //
@@ -1845,7 +1975,7 @@
         // we're looking for.  If we find one, return the corresponding interface
         // index, or -1 if not found.
         //
-        int32_t interface = ipv4->GetInterfaceForPrefix(a, amask);
+        int32_t interface = ip->GetInterfaceForPrefix(a, amask);
 
 #if 0
           if (interface < 0)
@@ -1877,8 +2007,10 @@
 // a destination IP address, reachable from the root, to which we add a host
 // route.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFIntraAddRouter(SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFIntraAddRouter(SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << v);
 
@@ -1890,7 +2022,7 @@
     // going to use this ID to discover which node it is that we're actually going
     // to update.
     //
-    Ipv4Address routerId = m_spfroot->GetVertexId();
+    IpAddress routerId = m_spfroot->GetVertexId();
 
     NS_LOG_LOGIC("Vertex ID = " << routerId);
     //
@@ -1909,7 +2041,7 @@
     // to GetObject for that interface.  If there's no GlobalRouter interface,
     // the node in question cannot be the router we want, so we continue.
     //
-    Ptr<GlobalRouter> rtr = node->GetObject<GlobalRouter>();
+    Ptr<GlobalRouter<T>> rtr = node->GetObject<GlobalRouter<T>>();
     NS_ASSERT_MSG(rtr, "No GlobalRouter interface on node " << node->GetId());
     //
     // If the router ID of the current node is equal to the router ID of the
@@ -1925,8 +2057,8 @@
         // GetObject for that interface.  If the node is acting as an IP version 4
         // router, it should absolutely have an Ipv4 interface.
         //
-        Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
-        NS_ASSERT_MSG(ipv4,
+        Ptr<Ip> ip = node->GetObject<Ip>();
+        NS_ASSERT_MSG(ip,
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "GetObject for <Ipv4> interface failed");
         //
@@ -1935,7 +2067,7 @@
         // Link Records corresponding to links off of that vertex / node.  We're going
         // to be interested in the records corresponding to point-to-point links.
         //
-        GlobalRoutingLSA* lsa = v->GetLSA();
+        GlobalRoutingLSA<IpManager>* lsa = v->GetLSA();
         NS_ASSERT_MSG(lsa,
                       "GlobalRouteManagerImpl::SPFIntraAddRouter (): "
                       "Expected valid LSA in SPFVertex* v");
@@ -1957,8 +2089,8 @@
             //
             // We are only concerned about point-to-point links
             //
-            GlobalRoutingLinkRecord* lr = lsa->GetLinkRecord(j);
-            if (lr->GetLinkType() != GlobalRoutingLinkRecord::PointToPoint)
+            GlobalRoutingLinkRecord<IpManager>* lr = lsa->GetLinkRecord(j);
+            if (lr->GetLinkType() != GlobalRoutingLinkRecord<IpManager>::PointToPoint)
             {
                 continue;
             }
@@ -1975,28 +2107,38 @@
             // Similarly, the vertex <v> has an m_rootOif (outbound interface index) to
             // which the packets should be send for forwarding.
             //
-            Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
+            Ptr<GlobalRouter<IpManager>> router = node->GetObject<GlobalRouter<IpManager>>();
             if (!router)
             {
                 continue;
             }
-            Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+            Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
             NS_ASSERT(gr);
             // walk through all available exit directions due to ECMP,
             // and add host route for each of the exit direction toward
             // the vertex 'v'
             for (uint32_t i = 0; i < v->GetNRootExitDirections(); i++)
             {
-                SPFVertex::NodeExit_t exit = v->GetRootExitDirection(i);
-                Ipv4Address nextHop = exit.first;
+                typename SPFVertex<T>::NodeExit_t exit = v->GetRootExitDirection(i);
+                IpAddress nextHop = exit.first;
                 int32_t outIf = exit.second;
                 if (outIf >= 0)
                 {
-                    gr->AddHostRouteTo(lr->GetLinkData(), nextHop, outIf);
-                    NS_LOG_LOGIC("(Route " << i << ") Node " << node->GetId()
-                                           << " adding host route to " << lr->GetLinkData()
-                                           << " using next hop " << nextHop
-                                           << " and outgoing interface " << outIf);
+                    if (lr->GetLinkData() != IpAddress::GetZero())
+                    {
+                        gr->AddHostRouteTo(lr->GetLinkData(), nextHop, outIf);
+                        NS_LOG_LOGIC("(Route " << i << ") Node " << node->GetId()
+                                               << " adding host route to " << lr->GetLinkData()
+                                               << " using next hop " << nextHop
+                                               << " and outgoing interface " << outIf);
+                    }
+                    else
+                    {
+                        NS_LOG_LOGIC("The Link Data field of the link record is zero, This link "
+                                     "Record is for an interface with no globalUnicast address,  "
+                                     "not adding a hostroute to it");
+                        continue;
+                    }
                 }
                 else
                 {
@@ -2016,8 +2158,9 @@
     NS_FATAL_ERROR("SPFIntraAddRouter(): routerId and vertex ID do not match");
 }
 
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFIntraAddTransit(SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFIntraAddTransit(SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << v);
 
@@ -2029,7 +2172,7 @@
     // going to use this ID to discover which node it is that we're actually going
     // to update.
     //
-    Ipv4Address routerId = m_spfroot->GetVertexId();
+    IpAddress routerId = m_spfroot->GetVertexId();
 
     NS_LOG_LOGIC("Vertex ID = " << routerId);
     //
@@ -2048,7 +2191,7 @@
     // to GetObject for that interface.  If there's no GlobalRouter interface,
     // the node in question cannot be the router we want, so we continue.
     //
-    Ptr<GlobalRouter> rtr = node->GetObject<GlobalRouter>();
+    Ptr<GlobalRouter<T>> rtr = node->GetObject<GlobalRouter<T>>();
     NS_ASSERT_MSG(rtr, "No GlobalRouter interface on node " << node->GetId());
     //
     // If the router ID of the current node is equal to the router ID of the
@@ -2074,23 +2217,30 @@
         // Link Records corresponding to links off of that vertex / node.  We're going
         // to be interested in the records corresponding to point-to-point links.
         //
-        GlobalRoutingLSA* lsa = v->GetLSA();
+        GlobalRoutingLSA<T>* lsa = v->GetLSA();
         NS_ASSERT_MSG(lsa,
                       "GlobalRouteManagerImpl::SPFIntraAddTransit (): "
                       "Expected valid LSA in SPFVertex* v");
-        Ipv4Mask tempmask = lsa->GetNetworkLSANetworkMask();
-        Ipv4Address tempip = lsa->GetLinkStateId();
-        tempip = tempip.CombineMask(tempmask);
-        Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
-        Ptr<Ipv4GlobalRouting> gr = router->GetRoutingProtocol();
+        IpMaskOrPrefix tempmask = lsa->GetNetworkLSANetworkMask();
+        IpAddress tempip = lsa->GetLinkStateId();
+        if constexpr (IsIpv4)
+        {
+            tempip = tempip.CombineMask(tempmask);
+        }
+        else
+        {
+            tempip = tempip.CombinePrefix(tempmask);
+        }
+        Ptr<GlobalRouter<T>> router = node->GetObject<GlobalRouter<T>>();
+        Ptr<GlobalRouting<IpRoutingProtocol>> gr = router->GetRoutingProtocol();
         NS_ASSERT(gr);
         // walk through all available exit directions due to ECMP,
         // and add host route for each of the exit direction toward
         // the vertex 'v'
         for (uint32_t i = 0; i < v->GetNRootExitDirections(); i++)
         {
-            SPFVertex::NodeExit_t exit = v->GetRootExitDirection(i);
-            Ipv4Address nextHop = exit.first;
+            typename SPFVertex<T>::NodeExit_t exit = v->GetRootExitDirection(i);
+            IpAddress nextHop = exit.first;
             int32_t outIf = exit.second;
 
             if (outIf >= 0)
@@ -2126,14 +2276,16 @@
 // Given a pointer to a vertex, it links back to the vertex's parent that it
 // already has set and adds itself to that vertex's list of children.
 //
+
+template <typename T>
 void
-GlobalRouteManagerImpl::SPFVertexAddParent(SPFVertex* v)
+GlobalRouteManagerImpl<T>::SPFVertexAddParent(SPFVertex<T>* v)
 {
     NS_LOG_FUNCTION(this << v);
 
     for (uint32_t i = 0;;)
     {
-        SPFVertex* parent;
+        SPFVertex<T>* parent;
         // check if all parents of vertex v
         if ((parent = v->GetParent(i++)) == nullptr)
         {
